#include "Tree.h"
#include<iostream>

using namespace std;

BinaryTree::BinaryTree()
{
	root = nullptr;
}

BinaryTree:: ~BinaryTree()
{
	cout << "mazani stromu" << endl;
	Clear(root);
}

void BinaryTree::Clear(node* nod)
{
	if (nod != nullptr)//pokud nezpracovavam prazdny (pod)strom
	{
		Clear(nod->left); //mazu levy podstrom, pravy podstrom a pak samotny uzel 
		Clear(nod->right);
		cout <<"mazu uzel s klicem: " <<nod->key << endl;
		delete nod;
	}
}

void BinaryTree::Insert(int x)
{
	Insert(x, root);
}

void BinaryTree::Insert(int x, node*& nod)
{
	if (nod == nullptr) //prazdne misto pro vlozeni nalezeno
	{
		nod = new node();
		nod->left = nullptr;
		nod->right = nullptr;
		nod->key = x;
	}
	else
		if (x<nod->key)  //vkladam mensi hodnotu nez aktualni klic, hledam misto pro vlozeni v levem podstromu
			Insert(x, nod->left);
		else
			if (x>nod->key) //vkladam vetsi hodnotu  nez aktualni klic, hledam misto pro vlozeni v pravem podstromu
				Insert(x, nod->right);
}

bool BinaryTree::Search(int x)
{
	return Search(x, root);
}

bool BinaryTree::Search(int x, node* nod)
{
	if (nod == nullptr)
		return false;

	if (nod->key == x)
		return true;

	if (x<nod->key)
		Search(x, nod->left);
	else
		if (x>nod->key)
			Search(x, nod->right);
}

void BinaryTree::InOrder()
{
	cout << "Serazeny vypis klicu:" << endl;
	InOrder(root);
}

void BinaryTree::InOrder(node* nod)
{
	if (nod != nullptr)//pokud nezpracovavam prazdny (pod)strom
	{
		InOrder(nod->left);//prvni vypis mensich klicu v levem podstromu, pak vypis klice ve zpracovavanem uzlu
		cout <<"uzel s klicem: "<<nod->key << endl;
		InOrder(nod->right);//nakonec vypis vetsich klicu v pravem podstromu
	}
}

int BinaryTree::Count()
{
	return Count(root);
}

int BinaryTree::Count(node* nod)
{
	if (nod == nullptr) //prazdny strom - nula uzlu
		return 0;
	else
		return 1 + Count(nod->left) + Count(nod->right); //neprazdy - 1 + pocet uzlu v levem + pocet uzlu v pravem podstromu
}

int BinaryTree::MaxKey()
{
	return MaxKey(root);
}

int BinaryTree::MaxKey(node* nod)
{
	if (nod->right == nullptr)//vpravem podstromu uz nic neni - mam maximum
		return nod->key;
	else
		return MaxKey(nod->right);
}

int BinaryTree::MinKey()
{
	return MinKey(root);
}

int BinaryTree::MinKey(node* nod)
{
	if (nod->left == nullptr)
		return nod->key;
	else
		return MaxKey(nod->left);
}







